//////////////////////////////////////////////////////////////////////////////
//	Copyright (C) 1998 Chris Cant, PHD Computer Consultants Ltd
/////////////////////////////////////////////////////////////////////////////

#ifndef __ABC_EVENTLOG__
#define __ABC_EVENTLOG__

/////////////////////////////////////////////////////////////////////////////
// Various constants

// Error-logging verbosity levels

#define LOG_LEVEL_NONE			0
#define LOG_LEVEL_NORMAL		1
#define LOG_LEVEL_DEBUG			2

#define  DEFAULT_LOG_LEVEL		LOG_LEVEL_DEBUG

// Unique values identifying location
// of an error within the driver 

#define ABC_ERRORLOG_INIT				1
#define ABC_ERRORLOG_DISPATCH			2
#define ABC_ERRORLOG_TRANSFER			3
#define ABC_ERRORLOG_TXBASICS			4
#define ABC_ERRORLOG_UNLOAD				5

// Largest number of insertion strings
// allowed in one message
#define ABC_MAX_INSERTION_STRINGS		20

/////////////////////////////////////////////////////////////////////////////
// Prototypes for globally defined functions...

VOID
AbcInitializeEventLog(
	IN PDRIVER_OBJECT DriverObject
	);

BOOLEAN
AbcReportEvent(
	IN ULONG	MessageLevel,
	IN NTSTATUS	ErrorCode,
	IN ULONG	UniqueErrorValue,
	IN PVOID	IoObject,
	IN PIRP		Irp,
	IN ULONG	DumpData[],
	IN ULONG	DumpDataCount,
	IN PWSTR	Strings[],
	IN ULONG	StringCount
	);

#endif	// __ABC_EVENTLOG__

